Ticket #34110

複数文節の日本語変換をした直後にすべての文節を通知する仕様の検討

Open Date: 2014-07-29 23:15 Last Update: 2014-08-11 11:55

Reporter: nishimoto Owner: (None)
Type: Bugs Status: Closed
Component: IME MileStone: 2014.3jp-public-beta (closed)
Priority: 5 - Medium Severity: 5 - Medium
Resolution: Fixed

Details

#31358 日本語入力(TSF)で文節ごとの候補の読み上げ での議論の続きですが、 本件は IMM32 と TSF の両方をカバーしないといけないので、チケットを独立させます。

「Word 2010文節の変換」 (span.jp) にて、文節変換の操作がどう解説されているか確認しました。

http://span.jp/office2010_manual/word2010/input/bunsetsu.html

文章全体を変換した際、スクリーンリーダーの音声が

  • すべての文節を読み上げる
  • 最初の文節(初期状態で選択された文節)だけを読み上げる

のふたつの場合があると書かれています。

2014.2jp までの実装では IMM32 では「常に選択された文節だけを読み上げる」仕様になっていて、 2014.3jp に向けた #31358 では、この IMM32 の仕様に併せて TSF でも「常に選択された文節だけを読み上げる」仕様を実装しています。

前述の記事によると、スクリーンリーダーの種類やモードによって下記の2種類の可能性があるようです:

  • 変換を最初に実行した直後はすべての文節を読み上げて、それ以降(文節区切り位置の変更や選択文節の移動)の操作に対しては選択中文節を読み上げる仕様
  • 常に選択中文節だけを読み上げる仕様

おそらく「常にすべての文節を読み上げる仕様」は考慮しなくてもよいように思われます。

本件に関連するご要望や情報をお聞かせください。

Attachment File List

No attachments

Ticket History (3/11 Histories)

2014-07-29 23:15 Updated by: nishimoto
  • New Ticket "複数文節の日本語変換をした直後にすべての文節を通知する仕様の検討" created
2014-07-29 23:31 Updated by: nishimoto
Comment

上記を書いたあとで、もういちど SPAN の解説を読みながら実際に Microsoft IME を操作してみましたが、 スクリーンリーダーがどう読み上げるかを詳しく書いてあるとは言えないので、

  • 常にすべての文節を読み上げる仕様
  • 変換を最初に実行した直後はすべての文節を読み上げて、それ以降(文節区切り位置の変更や選択文節の移動)の操作に対しては選択中文節を読み上げる仕様
  • 常に選択中文節だけを読み上げる仕様

のすべての可能性があると訂正しておきます。

なお、Windows 8.1 のナレーターも確認してみましたが、 第2候補を選択してポップアップが表示されるまで読み上げをしない (つまり文節を選択している状態での読み上げをサポートしていない)ので、 本件の仕様の参考にはならない状況です。

2014-07-31 11:51 Updated by: misono
Comment

(1)常にすべての文節を読み上げる仕様 (2)変換を最初に実行した直後はすべての文節を読み上げて、それ以降(文節区切り位置の変更や選択文節の移動)の操作に対しては選択中文節を読み上げる仕様 (3)常に選択中文節だけを読み上げる仕様

上記3種は、スクリーンリーダーごとの特性です。

NVDA 2014.2 までは (1) となっています。 (1)の仕様をまったく違う読み方に改めるのは、IME変換が、すべてのユーザーに対して影響を及ぼすことから 注意が必要です。したがって (3) に切り替えるよりは、 (2) をテストしてみることを検討してみては どうでしょうか。

なお (2) は JAWS と同じ仕様になります。

2014-07-31 12:46 Updated by: nishimoto
Comment

御教示ありがとうございます。

NVDA 2014.2jp までの実装が (1) だったように受け止められているのですが、 IMM32 系では (3) 「常に選択中の文節だけ通知」で実装されているはずです。 Windows XP を TSF 無効で使った場合や、 TSF をサポートしていない旧バージョンの ATOK では、 そういう動作をするはずです。

TSF 系では (3) が実装できていなかったため、 結果的に (1) のように動作していました。 しかしこれは不具合として受け止められていたと理解しています。

いままで意図していた仕様は (3) だったため #31358 では IMM32 にあわせて TSF を (3) の仕様で完成させることをカバーしていました。

(1) (2) の選択肢の議論の場としてこのチケットを作りましたので、こちらで引き続きご議論をお願いします。

2014-08-08 14:32 Updated by: misono
Comment

#31358: 日本語入力(TSF)で文節ごとの候補の読み上げ

での改良が完了したことで、こちらの検討ができるようになったわけですが、 数回にわたって書いていますように、 #31358 の変更は、日本語を扱うすべてのユーザーに 影響を与えます。

前掲の (2) での実装方法は JAWS の IME 対応でも使われており、 従来の NVDA 日本語版の変換中の読み方を網羅し、 #31358 も網羅するように考えられます。

#31358 がすべての日本語を扱うユーザーに影響を及ぼすことから、 このチケットも合わせてタスクを完了できるよう取り組んでいただきたいと考えます。

2014-08-08 18:44 Updated by: nishimoto
Comment

実現できそうなのでマイルストーンを設定しました:

作業ブランチの情報:

To ssh://git@bitbucket.org/nvdajp/nvdajp.git
 * [new branch]      ti34110 -> ti34110
2014-08-09 08:16 Updated by: nishimoto
Comment

日本語テスト版 jpbeta140809

https://dl.dropboxusercontent.com/u/62564469/nvda_jpbeta140809.exe

複数文節の日本語変換をした直後にすべての文節を通知する仕様を実装しました。

2014-08-09 14:52 Updated by: nishimoto
Comment

すでに候補ウィンドウが開いている状態で NVDA を起動するとエラーになる不具合の修正:

To ssh://git@bitbucket.org/nvdajp/nvdajp.git
   a41311b..ac3f35d  ti34110 -> ti34110
2014-08-09 16:41 Updated by: nishimoto
Comment

メモ帳の文字変換を Esc キーでクリアした直後に Thunderbird 31.0 のメッセージ閲覧に移動すると、 左右の矢印キーで文字が確認できない、というリグレッションが報告されたので、 実装をやり直しました。

To ssh://git@bitbucket.org/nvdajp/nvdajp.git
 * [new branch]      ti34110v2 -> ti34110v2
2014-08-10 08:20 Updated by: nishimoto
Comment

日本語テスト版 jpbeta140810

https://dl.dropboxusercontent.com/u/62564469/nvda_jpbeta140810.exe

Thunderbird 文字説明の不具合を起こさないように再実装した ti34110v2 ブランチのビルドです。

2014-08-11 11:55 Updated by: nishimoto
  • Ticket Close date is changed to 2014-08-11 11:55
  • Status Update from Open to Closed
  • Resolution Update from Accepted to Fixed
Comment

jpbeta ブランチにマージしました。

Edit

Please login to add comment to this ticket » Login